//Hanglejtszs Ajtcseng
//By MaSTeRFoXX
//holcsik@freemail.hu
//2007-07-05-  2007-08-02


//inclue-ok
#include <avr/io.h>
#include <delay.h>



// Define baud rate
#define USART_BAUD 57600ul
#define USART_UBBR_VALUE 9// -adatlapbl U2X=0
#define DF_deselect() PORTD|=(1<<PD3); //dataflash /CS lb vezrls
#define DF_select() PORTD&=~(1<<PD3);
#define SCK_H() PORTD|=(1<<PD4);
#define SCK_L() PORTD&=~(1<<PD4);
#define MOSI_H() PORTD|=(1<<PD5);
#define MOSI_L()  PORTD&=~(1<<PD5);
//#define LED_H() PORTD|=(1<<PD6);
//#define LED_L()  PORTD&=~(1<<PD6);
//#define DUMMY 0x00;

//parancsok
#define STATUS_READ 0xD7;
uint16_t buffer_addr, page_addr,x;
//buffer_addr:a bufferben lv adat cme , max 528 
//page_addr: a memriban lv lapok cme, max 4096
void clockpulse(void)
{
	SCK_H();
	_delay_us(20);
	SCK_L();
}


uint8_t SPI_RW(uint8_t output)
{
	uint8_t input;
	for(uint8_t i=0; i<8; i++)
		{
			input <<=1;	//balra shiftel
			if (output&0x80) //MSB elszr, megnzi a 7.bitet
			{
				MOSI_H();	//Ha 1 akkor ad egy 1-est a kimenetre
			}
			else 
			{	
				MOSI_L();	//ha 0 akkor egy L szintet ad a kimenetre
			}
			if(PIND & (1<<PIND2)) input++; //Ha  a bemenet 1 akkor hozzad 1-et
			clockpulse();
			output <<= 1;     //balra shiftel
		}
   return input;
}

void SPI_write(uint8_t outp)
{
	for(uint8_t i=0; i<8; i++)
		{
			if (outp&0x80) //MSB elszr, megnzi a 7.bitet
			{
				MOSI_H();	//Ha 1 akkor ad egy 1-est a kimenetre
			}
			else 
			{	
				MOSI_L();	//ha 0 akkor egy L szintet ad a kimenetre
			}
			clockpulse();
			outp <<= 1;     //balra shiftel
		}
}

uint8_t get_status(void)
{
	uint8_t status;
	DF_select();
	status=SPI_RW(0xD7); //sttuszregiszter olvass kldse
	status=SPI_RW(0x00); //dummy byte
	DF_deselect();
	return status;
}

void wait_until_rdy(void)
{
	//LED_H();
	while(!(get_status()&0x80)) {} //amig a ststusregiszter 7.bitje nem 1 addig foglalt a dataflash memria
	//LED_L();
}

uint8_t get_mfid(void)
{
	uint8_t mfid;
	DF_select();
	mfid=SPI_RW(0x9F); //gyrtazonost olvass kldse
	mfid=SPI_RW(0x00); //dummy byte
	DF_deselect();
	return mfid;
}
	


void USART_vInit(void)
{
// Set baud rate
UBRRH = (uint8_t)(USART_UBBR_VALUE>>8);
UBRRL = (uint8_t)USART_UBBR_VALUE;
// Set frame format to 8 data bits, no parity, 1 stop bit
//UCSRC |= (1 << URSEL) | (1 << UCSZ0) | (1 << UCSZ1); // Use 8-bit character sizes
//UCSRC |=(1<<UCSZ0) |(1<<UCSZ1);
UCSRB = (1<<RXEN)|(1<<TXEN);
UCSRC = (1 << UCSZ1) | (1 << UCSZ0);
// Enable receiver and transmitter
//UCSRB = (1<<RXEN)|(1<<TXEN);
}

void USART_vSendByte(uint8_t u8Data)
{
// Wait if a byte is being transmitted
while((UCSRA&(1<<UDRE)) == 0);
// transmit data
UDR = u8Data;
}


uint8_t USART_vReceiveByte(void)
{
// Wait until a byte has been received
//while((UCSRA&(1<<RXC)) == 0);
while (!(UCSRA & (1 << RXC)));
// Return received data
return UDR;
}

void DF_erase(void)	//ez trli ki a mememrit 50H block erase paranccsal
{
	uint16_t block; //ez trolja hogy melyik blokkal dolgozzon
	block=0;
	while(block<512)
		{
		DF_select();
		SPI_write(0x50); //Block erase parancs
		SPI_write(block>>3); //eltolni jobbra3 -mal
		SPI_write(block<<5); //eltolni balra 5-tel
		SPI_write(0x00);
		DF_deselect();
		block++;
		wait_until_rdy();
		}
}

void DF_write(uint8_t dat)
{
	wait_until_rdy(); //vrjon amig el nem kszl egy elz mvelettel
	DF_select();
	SPI_write(0x84); //buffer1 write parancs
	SPI_write(0x00); //don't care
	SPI_write(buffer_addr>>8); //8-al eltolni jobbra hogy csak 1 bit maradjon belle
	SPI_write(buffer_addr); //kldje el a maradk cmet
	SPI_write(dat); //vgl rja be a bufferba az adatot
	DF_deselect(); 
	buffer_addr++;
	if(buffer_addr>528) //tele van a buffer, rakja rja be a flash memriba
	{
		buffer_addr=0;
		if(page_addr<4096) //ha nincs mg tele a memria
		{
			DF_select();
			SPI_write(0x88); //buffer->memriba trls nlkl parancs
			SPI_write(page_addr>>6);
			SPI_write(page_addr<<2);
			SPI_write(0x00); //don't care
			DF_deselect();
			page_addr++;
		}
		else
		{
			page_addr=0;
		}
	}
}

void play(void)
{
	uint8_t dat;	//bejv adat
	wait_until_rdy();
	DF_select();
	SPI_write(0xE8); //Folyamatos olvass parancs
	SPI_write(0x00); //A 3 cm byte (0, mivel az elejrl kezddik)
	SPI_write(0x00);
	SPI_write(0x00); 
	SPI_write(0x00); //A 4 don't care byte
	SPI_write(0x00);
	SPI_write(0x00);
	SPI_write(0x00);
	dat=2;
	while(!(dat==1))
	{
		dat=SPI_RW(0x00); //csak rajelet kell adni s jn be az adat
		PORTB=dat;
		//USART_vSendByte(dat);
		for(uint8_t i=0; i<11; i++)
			{
			_delay_us(10);
			}
			
		
	}
	DF_deselect();
	//USART_vSendByte(x);
}

void USART_Flush(void)
{
uint8_t dummy;
while ( UCSRA & (1<<RXC) ) dummy = UDR;
}

void write(void) //ez rja be a bejv adatot a flash memriba
{
	uint8_t usart_dat;
	page_addr=0;
	buffer_addr=0;
	while(!(usart_dat==0))
	{
		usart_dat=USART_vReceiveByte();
		DF_write(usart_dat);
	}
	_delay_us(100);
	//A bufferban maradt adat bementse a memriba
	DF_select();
	SPI_write(0x88); //buffer->memriba trls nlkl parancs
	SPI_write(page_addr>>6);
	SPI_write(page_addr<<2);
	SPI_write(0x00); //don't care
	DF_deselect();
}
int main(void)
{ 
	DDRB=0XFF; //kimenet, ide kerl ki a hang
	uint8_t u8Data;
	DDRD&=~(1<<PD0); //bemenet
	DDRD|=(1<<PD1); //kimenet
	
	USART_vInit();
	
	DDRD&=~(1<<PD2); //SO, itt jn be az adat
	DDRD|=(1<<PD3); //  /CS, chip select
	DDRD|=(1<<PD4); // SCK
	DDRD|=(1<<PD5); // SI, itt megy ki az adat
	DDRD&=~(1<<PD6); //ez az zemmdvlaszt jumper
	
	PORTD&=~(1<<PD5); //Mosi legyen L
	PORTD&=~(1<<PD4); //SCK legyen L
	_delay_ms(255);
	DF_deselect();
	DF_select();
	DF_deselect();
	_delay_ms(255);
	buffer_addr=0;
	page_addr=0;
	x=0;
//	LED_L();
	while(1)
	{
	if(!(PIND&(1<<PIND6)))
		{
		while(1)
			{
			//
			//DDRD|=(1<<PD6);	//specialis mod: a jumperes labrol relet vezerelni....
			//PORTD|=(1<<PD6);
			//
			play();
			//
			//PORTD&=~(1<<PD6);
			//_delay_ms(255);
			//_delay_ms(255);
			//_delay_ms(255);
			//_delay_ms(255);
			//_delay_ms(255);
			}
		}
	u8Data=USART_vReceiveByte();
	USART_Flush();
	if (u8Data==66) 
		{
		USART_vSendByte(get_mfid());
		wait_until_rdy();
		USART_vSendByte(get_status());
		}
	if (u8Data==67) 
		{
		DF_erase();
		USART_vSendByte(get_status());
		}
	if (u8Data==68) 
		{
		write();
		}
	if (u8Data==69) 
		{
		play();
		}
	USART_vSendByte(u8Data);
	}
}

